unit dlg_ParaProps;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, frm_Hoved, WordSource;

type
  TdlgParaProps = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    e_FirstIndent: TEdit;
    e_LeftIndent: TEdit;
    e_RightIndent: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    e_SpaceAfter: TEdit;
    Label5: TLabel;
    rg_NumberType: TRadioGroup;
    cb_BulletType: TComboBox;
    Label6: TLabel;
    cbx_LeftBorder: TCheckBox;
    cbx_TopBorder: TCheckBox;
    cbx_RightBorder: TCheckBox;
    cbx_BottomBorder: TCheckBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    e_BorderWidth: TEdit;
    Label11: TLabel;
    Label13: TLabel;
    lb_Tabs: TListBox;
    Label14: TLabel;
    e_SpaceBefore: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    e_TabValue: TEdit;
    Label15: TLabel;
    e_BorderMargin: TEdit;
    Label16: TLabel;
    rg_Alignment: TRadioGroup;
    e_LineSpacing: TEdit;
    Label17: TLabel;
    cbx_KeepWithNext: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dlgParaProps: TdlgParaProps;

implementation

{$R *.dfm}

procedure TdlgParaProps.FormShow(Sender: TObject);
var
  Para : TWSParagraph;
  i : integer;
begin
    Para := frmHoved.ws.ParaAttributes[frmHoved.ws.CurrentParaNumber];
    with Para do
    begin
         e_FirstIndent.Text := IntToStr(FirstIndent);
         e_LeftIndent.Text := IntToStr(LeftIndent);
         e_RightIndent.Text := IntToStr(RightIndent);
         e_SpaceBefore.Text := IntToStr(SpaceBefore);
         e_SpaceAfter.Text := IntToStr(SpaceAfter);
         e_LineSpacing.Text := IntToStr(Linespacing);
         if Numbering = pnNone then rg_NumberType.ItemIndex := 2
         else if Numbering  = pnNumber then rg_NumberType.ItemIndex := 1
         else rg_NumberType.ItemIndex := 0;
         if (Numbering <> pnNone) and (Numbering <> pnNumber) then
         begin
             case Numbering of
             pnBullet : cb_BulletType.ItemIndex := 0;
             pnArrow : cb_BulletType.ItemIndex := 1;
             pnCandle : cb_BulletType.ItemIndex := 2;
             pnCheckmark : cb_BulletType.ItemIndex := 3;
             pnSmiley : cb_BulletType.ItemIndex := 4;
             pnStar : cb_BulletType.ItemIndex := 5;
             end;
         end
         else
           cb_BulletType.ItemIndex := -1;
         cbx_LeftBorder.checked := (pbLeft in Borders);
         cbx_RightBorder.checked := (pbRight in Borders);
         cbx_BottomBorder.checked := (pbBottom in Borders);
         cbx_TopBorder.checked := (pbTop in Borders);
         e_BorderWidth.Text := IntToStr(BorderWidth);
         e_BorderMargin.Text := IntToStr(BorderSpace);
         cbx_KeepWithNext.Checked := KeepWithNext;
         lb_Tabs.Clear;
         e_TabValue.Text := '';
         for i := 0 to TabCount - 1 do
         begin
              lb_Tabs.Items.Add(IntTostr(Tabs[i]));
         end;
         rg_Alignment.ItemIndex := Ord(Alignment);
    end;
end;

procedure TdlgParaProps.SpeedButton2Click(Sender: TObject);
begin
     if Trim(e_tabValue.Text) <> '' then
       lb_Tabs.Items.Add(e_TabValue.Text);
end;

procedure TdlgParaProps.SpeedButton1Click(Sender: TObject);
begin
      lb_Tabs.Items.Delete(lb_Tabs.ItemIndex);
end;

procedure TdlgParaProps.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  Para : TWSParagraph;
  i : integer;
begin
    if ModalResult <> mrOK then
      Exit;
    Para := frmHoved.ws.EditParagraph(frmHoved.ws.CurrentParaNumber);
    Para.BeginChange;
    with Para do
    begin
         FirstIndent := StrToInt(e_FirstIndent.Text);
         LeftIndent := StrToInt(e_LeftIndent.Text);
         RightIndent := StrToInt(e_RightIndent.Text);
         SpaceBefore := StrToInt(e_SpaceBefore.Text);
         SpaceAfter := StrToInt(e_SpaceAfter.Text);
         LineSpacing := StrToInt(e_LineSpacing.Text);
         if rg_NumberType.ItemIndex = 2 then Numbering := pnNone;
         if rg_NumberType.ItemIndex = 1 then Numbering  := pnNumber
         else if rg_NumberType.ItemIndex = 0 then
         begin
             case cb_BulletType.ItemIndex of
             -1,0: Numbering := pnBullet;
             1: Numbering := pnArrow;
             2: Numbering := pnCandle;
             3: Numbering := pnCheckmark;
             4: Numbering := pnSmiley;
             5: Numbering := pnStar;
             end;
         end;
         Borders := [];
         if cbx_LeftBorder.Checked then Borders := Borders + [pbLeft];
         if cbx_RightBorder.checked then Borders := Borders + [pbRight];
         if cbx_BottomBorder.checked then Borders := Borders + [pbBottom];
         if cbx_TopBorder.checked then Borders := Borders + [pbTop];
         BorderWidth := StrToInt(e_BorderWidth.Text);
         BorderSpace := StrToInt(e_BorderMargin.Text);
         KeepWithNext := cbx_KeepWithNext.Checked;
         TabCount := lb_Tabs.Items.Count;
         for i := 0 to lb_Tabs.Items.Count - 1 do
         begin
              Tabs[i] := StrToInt(lb_Tabs.Items[i]);
         end;
         Alignment := TAlignment(rg_Alignment.ItemIndex);

    end;
    Para.EndChange;
end;

end.
