unit frm_Hoved;

{******************* WordSource demo application **************************
This demo application is designed for working with the Delphi IDE and is not
intended for commersial use. Compiling the application assumes you have
the WordSource component installed.

Though it contains many editing function, the purpose of the demo application
is to demonstrate key features of the WordSource component,
not to be a fully functional wordprocesser.

Note that the demo screens access files that must be available by path
or by running the application from the directory where the files reside.
***************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, WordSource, Menus, ImgList,
  ActnList, ToolWin, Printers, Buttons, OleCtnrs, winspool, ShellAPI;

const
  LB = #13#10;
  LS = #12#12;

  WM_ChangeScreen = wm_User + 100;

  {Sample keystring list for delphi reserved words. This list can be loaded by
  calling SetDelphiKeystrings}
  DKeystrCount = 60;
  DelphiKeystrings : array[1..DKeyStrCount] of string =
  ('program',
  'library',
  'type',
  'class',
  'property',
  'record',
  'array',
  'object',
  'set',
  'string',
  'of',
  'is',
  'as',
  'in',
  'on',
  'unit',
  'private',
  'protected',
  'published',
  'interface',
  'uses',
  'const',
  'override',
  'overlaod',
  'message',
  'procedure',
  'function',
  'var',
  'begin',
  'end',
  'if',
  'then',
  'else',
  'do',
  'for',
  'while',
  'repeat',
  'until',
  'to',
  'downto',
  'with',
  'and',
  'or',
  'not',
  'xor',
  'shl',
  'muldiv',
  'try',
  'finally',
  'except',
  'raise',
  'case',
  'inherited',
  'nil',
  'div',
  'mod',
  'initialization',
  'constructor',
  'destructor',
  'goto');


type
  TRulerMode = (rmNoIndent, rmFirstIndent, rmLeftIndent, rmHangIndent, rmRightIndent);

  TfrmHoved = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    Rediger1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ActionList1: TActionList;
    ac_Bold: TAction;
    ImageList1: TImageList;
    ac_Italic: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ac_Underline: TAction;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ac_Font: TAction;
    FontDialog1: TFontDialog;
    OpenDialog1: TOpenDialog;
    ac_Open: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    FindDialog1: TFindDialog;
    ac_Find: TAction;
    ac_Print: TAction;
    ac_Replace: TAction;
    Print1: TMenuItem;
    ReplaceDialog1: TReplaceDialog;
    ac_Save: TAction;
    SaveDialog1: TSaveDialog;
    ac_AutoFormat: TAction;
    ac_Clear: TAction;
    N1: TMenuItem;
    Clear1: TMenuItem;
    Save1: TMenuItem;
    Demos1: TMenuItem;
    Usingautoformat1: TMenuItem;
    Workingwithgraphics1: TMenuItem;
    Intro1: TMenuItem;
    Open1: TMenuItem;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ImageList2: TImageList;
    Format1: TMenuItem;
    Paragraph1: TMenuItem;
    Font1: TMenuItem;
    ac_InsertFile: TAction;
    Insertfile1: TMenuItem;
    ac_ParaFormat: TAction;
    PopupMenu1: TPopupMenu;
    ac_InsertObject: TAction;
    Insertobject1: TMenuItem;
    Edit1: TMenuItem;
    Finn1: TMenuItem;
    Replacetext1: TMenuItem;
    Edit2: TMenuItem;
    ac_Copy: TAction;
    ac_Paste: TAction;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    ac_Undo: TAction;
    Undolastchange1: TMenuItem;
    ac_NewTopic: TAction;
    Newtopic1: TMenuItem;
    ac_TopicLinker: TAction;
    opiclinker1: TMenuItem;
    ac_BulletList: TAction;
    ac_numberlist: TAction;
    N2: TMenuItem;
    Bulletlist1: TMenuItem;
    Numberedlist1: TMenuItem;
    panFootnote: TPanel;
    e_Footnote: TEdit;
    Label1: TLabel;
    sbUpdateFN: TSpeedButton;
    sbNewFN: TSpeedButton;
    cbNewFN: TComboBox;
    ac_SaveAs: TAction;
    Saveas1: TMenuItem;
    ac_UpdateFootNote: TAction;
    pan_WS: TPanel;
    ws: TWordSource;
    pb: TPaintBox;
    pan_Left: TPanel;
    pan_Right: TPanel;
    pan_Auto: TPanel;
    sb_MrkAttr: TSpeedButton;
    sb_QuoteAttr: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton3: TSpeedButton;
    sb_KSAttr: TSpeedButton;
    mem_Markers: TMemo;
    mem_KeyStrings: TMemo;
    cbx_Single: TCheckBox;
    cbx_Dbl: TCheckBox;
    UsingTWSObject1: TMenuItem;
    CreatinWinHelpfiles1: TMenuItem;
    ac_Hyperlink: TAction;
    Hyperlink1: TMenuItem;
    N3: TMenuItem;
    procedure ac_BoldExecute(Sender: TObject);
    procedure ac_ItalicExecute(Sender: TObject);
    procedure ac_UnderlineExecute(Sender: TObject);
    procedure ac_FontExecute(Sender: TObject);
    procedure ac_OpenExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ac_FindExecute(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ac_PrintExecute(Sender: TObject);
    procedure ac_SaveUpdate(Sender: TObject);
    procedure ac_SaveExecute(Sender: TObject);
    procedure wsDrawScreen(Sender: TObject; Canvas: TCanvas);
    procedure wsAutoFormat(Sender: TObject; KeyStringKind: TKeyStringKind;
      var TheString: String; var Range: TRange;
      var Attributes: TAttributes);
    procedure wsSelChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ac_AutoFormatExecute(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure mem_KeyStringsChange(Sender: TObject);
    procedure cbx_SingleClick(Sender: TObject);
    procedure cbx_DblClick(Sender: TObject);
    procedure sb_KSAttrClick(Sender: TObject);
    procedure ac_ClearExecute(Sender: TObject);
    procedure wsDrawLine(Sender: TObject; Canvas: TCanvas; LeftMarginRect,
      LineRect: TRect; LineNumber: Integer; Selection: TRange;
      var FormatOptions: TFormatOptions; var DefaultDraw: Boolean);
    procedure wsAfterTextChange(Sender: TObject;
      ChangeKind: TTextChangeKind; Text: String; Range: TRange);
    procedure Intro1Click(Sender: TObject);
    procedure Usingautoformat1Click(Sender: TObject);
    procedure Workingwithgraphics1Click(Sender: TObject);
    procedure FontDialog1Close(Sender: TObject);
    procedure pbPaint(Sender: TObject);
    procedure pbMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pbMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pbMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure wsDrawObject(Sender: TObject; Source: TWSObject;
      Canvas: TCanvas; X, Y: Integer; var DefaultDraw: Boolean);
    procedure ac_InsertFileExecute(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure ac_ParaFormatExecute(Sender: TObject);
    procedure ac_ParaFormatUpdate(Sender: TObject);
    procedure ac_InsertObjectExecute(Sender: TObject);
    procedure ac_InsertObjectUpdate(Sender: TObject);
    procedure ac_PasteExecute(Sender: TObject);
    procedure ac_PasteUpdate(Sender: TObject);
    procedure ac_CopyExecute(Sender: TObject);
    procedure ac_CopyUpdate(Sender: TObject);
    procedure ac_UndoExecute(Sender: TObject);
    procedure ac_UndoUpdate(Sender: TObject);
    procedure ac_NewTopicExecute(Sender: TObject);
    procedure ac_TopicLinkerExecute(Sender: TObject);
    procedure ac_BulletListExecute(Sender: TObject);
    procedure ac_BulletListUpdate(Sender: TObject);
    procedure ac_numberlistExecute(Sender: TObject);
    procedure wsObject(Sender: TObject; Source: TWSObject);
    procedure ac_SaveAsExecute(Sender: TObject);
    procedure ac_UpdateFootNoteExecute(Sender: TObject);
    procedure ac_UpdateFootNoteUpdate(Sender: TObject);
    procedure sbNewFNClick(Sender: TObject);
    procedure ToolButton12Click(Sender: TObject);
    procedure wsSaveObject(Sender: TObject; Source: TWSObject);
    procedure wsLimitation(Sender: TObject; ErrorCode: Integer;
      ErrorMsg: String; var Cancel: Boolean);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure wsReplaceText(Sender: TObject; OldText, NewText: String;
      Index: Integer; var Allow, Cancel: Boolean);
    procedure ac_ReplaceExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure UsingTWSObject1Click(Sender: TObject);
    procedure CreatinWinHelpfiles1Click(Sender: TObject);
    procedure ac_NewTopicUpdate(Sender: TObject);
    procedure ac_TopicLinkerUpdate(Sender: TObject);
    procedure wsMarker(Sender: TObject; TheString: String;
      Action: TTextChangeKind; Range: TRange);
    procedure wsKeyString(Sender: TObject; TheString: String;
      Action: TTextChangeKind; Range: TRange);
    procedure ac_HyperlinkExecute(Sender: TObject);
    procedure ac_HyperlinkUpdate(Sender: TObject);
    procedure wsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure wsKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
    FCurScreen : integer; {Current demo screen}
    FLandscape : TBitMap;
    FKeyStrList : TList;
    FKeyListDirty : Boolean;
    FOrigAttributes : TAttributes;
    FRulerMode : TRulerMode;
    FRulerX : integer;
    FRulerStartX : integer;
    FIndentRectDiff : integer;
    MethodIcon : TBitmap;
    FCurrentFootNote : TWSFootnote;
    procedure SetScreen(ScreenNo : integer);
    procedure SetStyle(Include : Boolean; Style : TFontStyle);
    function GetFiRect : Trect;
    function GetLiRect : Trect;
    function GetRiRect : Trect;
    function GetHangRect : Trect;
    procedure InvalidatePB;
    function FontToAttributes(AFont : TFont) : TAttributes;
    procedure SetDelphiKeyStrings;
    procedure WMChangeScreen(var Message : TMessage); message wm_ChangeScreen;
  public
    { Public declarations }
    property FiRect : Trect read GetFIrect;
    property HangRect : TRect read GetHangRect;
    property LiRect : TRect read GetLiRect;
    property RiRect : TRect read GetRiRect;
  end;

  TWSBookmark = class(TWSTextObject)
  {Simple bookmark object. Not used in demo}
  protected
    procedure Draw(Canvas : TCanvas; X, Y : integer); override;
  end;

  THyperlinkStyle = (hsStaticUnderline, hsShowVisited, hsWantCtrlKey);
  THyperlinkStyles = set of THyperlinkStyle;

  TWSHyperlink = class(TWSTextObject)
  {To embed hyperlinks into a document using TWSObject is a fairly easy task.
  In fact there is not too much coding required.
  Obviously the TWSTextObject class is the right starting point, as this class
  is aimed at connecting functionality to a chunck of text.

  You can see how it works by chosing the Hyperlink command from the File menu.

  The reason for not including the hyperlink object in WordSource? Well,
  it should in fact be part of wider concept. A hyperlink is a 'field' in rtf-terms and
  the right base class is probably something like TWSField on which the
  hyperlink object should be based.}

   private
     FTarget : string;
     {Url or file target}
     FStyle : THyperlinkStyles;
     FUnderlined : Boolean;
     FVisited : Boolean;
     procedure SetTarget(Value : string);
   protected
     function CanReadGroup(ACtrlWord : string; Reader : TRtfRead) : Boolean; override;
     function CreateLinkObject(Reader : TRtfRead; ReadInfo : TReadInfo) : TWSObject;
     procedure MouseEnter; override;
     procedure MouseLeave; override;
     procedure MouseMoving(X, Y : integer; MouseIsDown : Boolean; var Cursor : TCursor); override;
     procedure MousePressed(Button : TMouseButton; Shift : TShiftState; X, Y : integer;
     var Cursor : TCursor; var StartSize : Boolean); override;
     function ReadRtf(Reader : TRtfRead; ReadInfo : TReadInfo) : TWSObject; override;
     function WriteRtf(Writer : TRtfWrite; WriteInfo : TWriteInfo) : string; override;
   public
     constructor Create(AnOwner : TWordSource; InitialScope : integer);
     property Target : string read FTarget write SetTarget;
     property Style : THyperlinkStyles read FStyle write FStyle;
     property Underlined : Boolean read FUnderlined write FUnderlined;
     procedure ApplyAttributes; override;
     procedure RefreshCursor; override;
     procedure UpdateText(Event : TTextChangeKind); override;
   end;

  TWSInternalLink = class(TWSHyperlink)
  {Used to navigate internally. Instansiated programatically in Intro screen}
  private
     FApp : TfrmHoved;
  public
     function CanReadGroup(ACtrlWord : string; Reader : TRtfRead) : Boolean; override;
     constructor Create(AnOwner : TWordSource; InitialScope : integer; ParentApp : TfrmHoved);
     procedure MousePressed(Button : TMouseButton; Shift : TShiftState; X, Y : integer;
      var Cursor : TCursor; var StartSize : Boolean); override;
     function ReadRtf(Reader : TRtfRead; ReadInfo : TReadInfo) : TWSObject; override;
     function WriteRtf(Writer : TRtfWrite; WriteInfo : TWriteInfo) : string; override;
     property App : TfrmHoved read FApp;
  end;

var
  frmHoved: TfrmHoved;

implementation
uses Math, dlg_ParaProps, dlg_WinHelp, frm_Jumper;

{$R *.dfm}

procedure TWSBookmark.Draw(Canvas : TCanvas; X, Y : integer);
var
  Hght : integer;
  Pt : Tpoint;
  Ind : integer;
begin
   Pt.X := X;
   Pt.Y := Y;
   Ind := Owner.PointToIndex(Pt, True);
   Hght := Owner.CharHeight[Ind];
   Canvas.Pen.Color := clSilver;
   Canvas.Pen.Width := 2;
   Canvas.MoveTo(X, Y);
   Canvas.LineTo(X, Y + Hght);
   if Scope > 0 then
   begin
     Inc(Ind, Scope+1);
     Pt := Owner.IndexToPoint(Ind);
     Hght := Owner.CharHeight[Ind];
     Canvas.Pen.Color := clSilver;
     Canvas.Pen.Width := 2;
     Canvas.MoveTo(Pt.X, Pt.Y);
     Canvas.LineTo(Pt.X, Pt.Y + Hght);
   end;
end;

{TWSHyperlink ----------------------------------------------------------}

procedure TWSHyperlink.SetTarget(Value : string);
begin
    if FTarget = Value then
      Exit;
    FTarget := Value;
    if Working and Assigned(Owner) then
      Owner.Modified := True;
end;

procedure TWSHyperlink.RefreshCursor;
{Refreshes the cursor when user pressing the control button. This method is
called from the OnKeyDown, OnKeyUp event hendler}
var
  St : integer;
begin
     if hsWantCtrlKey in Style then
     begin
       St := Hi(GetKeyState(VK_LCONTROL));
       if St = 0 then
        Owner.Cursor := Owner.TextCursor
       else
         Owner.Cursor := crHandPoint;
     end
     else
       Owner.Cursor := crHandPoint;
end;

procedure TWSHyperlink.MouseEnter;
{According to Style do what necessary when the mouse enters the hyperlink text}
begin
    if not (hsStaticUnderline in Style) then
    begin
        Style := Style + [hsStaticUnderline];
        UpdateText(ckChanged);
        Style := Style - [hsStaticUnderline];
    end;
end;

procedure TWSHyperlink.MouseLeave;
{According to Style do what necessary when the mouse leaves the hyperlink text}
begin
    if not (hsStaticUnderline in Style) then
    begin
        UpdateText(ckChanged);
    end;
end;

procedure TWSHyperlink.MouseMoving(X, Y : integer; MouseIsDown : Boolean; var Cursor : TCursor);
{Override MouseMoving to apply the Handpoint cursor when mouse moves over the hyperlink text}
var
  St : integer;
begin
     if hsWantCtrlKey in Style then
     begin
       St := Hi(GetKeyState(VK_LCONTROL));
       if St = 0 then
         Exit;
     end;
     Cursor := crHandPoint;
end;

procedure TWSHyperlink.MousePressed(Button : TMouseButton; Shift : TShiftState; X, Y : integer;
   var Cursor : TCursor; var StartSize : Boolean);
{Override MousePressed to execute the target and change the color of the hyperlink text}
var
  P : array[0..255] of Char;
begin
   if (Button <> mbLeft) then
     Exit;
   if (hsWantCtrlKey in Style) and  (Hi(GetKeyState(VK_LCONTROL)) = 0) then
     Exit;
   StrPCopy(P, FTarget);
   if ShellExecute(Owner.Handle, 'open', P, nil, nil, SW_SHOW) < 32 then
     raise Exception.Create('Target ' + FTarget + ' could not be accessed.');
   FVisited := True;
   UpdateText(ckChanged);
end;

procedure TWSHyperlink.UpdateText(Event : TTextChangeKind);
{Set hyperlink text attributes according to style and state}
var
  Attr : TAttributes;
begin
     Owner.DisableUndoRecording(taAttributes);
     {Prevent attributes from being undone as an isolated attribute change.
     Undoing a hyperlink will include the change of attributes if ncessary}
     try
       if Event in [ckAdded, ckChanged] then
       begin
         ApplyAttributes;
       end
       else {Deleted}
       begin
         {This removes underling and sets fontcolor to black}
         Attr.FontStyle := [];
         Attr.FontColor := clBlack;
         Owner.MergeAttributes(Attr, [caUnderline, caFontColor], TextRange);
       end;
     finally
       Owner.DisableUndoRecording(taNone);
     end;
end;

function TWSHyperlink.CanReadGroup(ACtrlWord : string; Reader : TrtfRead) : Boolean;
{Hyperlinks are implemented as rtf-fields. Accept processing the main "field" group.
It is also important that the subgroups "fldinst" and "fldrslt" are accepted, else the
WordSource kernel will skip these groups}
var
  S : string;
begin
   Result := False;
   if (ACtrlWord = 'field') then
   begin
      S := Reader.FindSubGroup('fldinst');
      {Check if the HYPERLINK field identifier is present}
      if Pos('HYPERLINK "', S) = 0 then
        Exit;
   end;
   Result := (ACtrlWord = 'field') or (ACtrlWord = 'fldinst') or (ACtrlWord = 'fldrslt');
end;

function TWSHyperlink.WriteRtf(Writer : TRtfWrite; WriteInfo : TWriteInfo) : string;
{A savable object has to transform it's properties and methods into rtf commands and tokens.
This is not difficult as you yourself decide the rtf-design. Parsing rtf is much
more demanding, because you must take into consideration different ways of
implementing the same rtf funcionality.

In rtf, hyperlinks are implemented as "fields". A field group consists of a field
instruction sub group and a field result sub group. To tell a hyperlik from
other kinds of fields, the identifier HYPERLINK initiates the instruction group
followed by the target. The result group contains the hyperlink text, as it is
seen by the user. This is the conseptual syntax.}

// {\field {\*\fldinst HYPERLINK "<Target>"}{\fldrslt <HyperlinkText>}}

{Our task is to convert the hyperlink object to this format}

begin
    Result := inherited WriteRtf(Writer, WriteInfo);
    if (Result <> '') then
      Exit;
    if ClassType = TWSHyperlink then
    begin
      Result := '{\field {\*\fldinst HYPERLINK "' + FTarget + '" }' +
      '{\fldrslt ' + WriteInfo.ResultText + '}}';
    end;

    {As you see, not much of a challenge, only a couple of things to be aware of:

    Always call the inherited WriteRtf. If this returns a none empty string,
    use it and jump out. The inherited TWSObject method takes care of writing
    to the undobuffer, and if you ignore or modify the delivered string, the
    undo system will not function correctly.

    Note also the WriteInfo feld ResultText. This value is not the result text
    itself but a placeholder for the text. You need it to position the
    rtf elements in accordance with the text. For the hyperlink, it indicates
    that the close brace terminators should appear after the result text.}
end;

function TWSHyperlink.ReadRtf(Reader : TRtfRead; ReadInfo : TReadInfo) : TWSObject;
{After having implemented the WriteRtf method you can save the file and the
hyperlink rtf commands are saved with it. However, you are still not able to
read them back. In fact, the result text is read, but the hyperlink functionality
is ignored. So, now comes the tricky part - the ReadRtf method which is
responsible for creating TWSObjects from rtf-commands. If you inspect an rtf
file generated by Microsoft Word you will see big amounts of rtf commands. A
rtf reader must be capable of parsing out those commands that should be handled
and skipping those that are of no interest. This is the real challenge of an
rtf reader. A MS Word implementation of a hyperlink may look like this:}

// {\field{\*\fldinst {\rtlch\fcs1 \af0 \ltrch\fcs0
// \insrsid11890583  HYPERLINK "http://www.mydomain.com" }
// {\rtlch\fcs1 \af0 \ltrch\fcs0 \insrsid11890583
// {\*\datafield 0d0c9ea79f9bace118c8200aa004ba90b0200000003000000e0c9ea79f9ba
// ce118c8200aa004ba90b3200000068007400740070003a002f002f007700770077002e006d00
// 790064006f006d00610069006e002e0063006f006d002f000000}}}
// {\fldrslt {\rtlch\fcs1 \af0 \ltrch\fcs0\cs15\ul\cf2\insrsid11890583
// \charrsid11890583 MyHyperlink}}}

{WordSource parses out the rtf elements one by one. When an element not handled
by the kernel rtf reader is detected, the different TWSObjects are given a
chance to handle it via the ReadRtf method. This method must recognize the
initiating group command and start working from there. For the hypelink object,
the \field command signals that this group might be of interest. Aditionally
it must check the group content to see if the HYPERKLINK field
identifer is present.

Note that the ReadRtf method when called by WordSource belongs to the object
that was registered with RegisterTWSObject procedure. The task of this object
is to be a factory for real working objects.}
var
  S : string;
begin
      Result := inherited ReadRtf(Reader, ReadInfo);
      {Always call inherited as this will ensure correct undo-processing
      when reviving a formely deleted object}
      if Result <> nil then
        Exit;

      with ReadInfo do
      if (ACtrlWord = 'field') then
      begin
         {The kernel rtf Reader object offers a useful function FindSubGroup
         that lets you examine the content of a sub group without reading the
         elements one by one, thus incrementing the readpointer.
         If the HYPERLINK identifier is found, we know it's pure gold and can
         start the reading loop.}

         S := Reader.FindSubGroup('fldinst');
         if Pos('HYPERLINK "', S) = 0 then
           Exit;
         Result := CreateLinkObject(Reader, ReadInfo);
         {Perform the reading loop and creation of object}
      end;
end;

function TWSHyperLink.CreateLinkObject(Reader : TRtfRead; ReadInfo : TReadInfo) : TWSObject;
{Does the actual parsing. Called by both TWSHyperlink and TWSInternallink}
var
  BraceCount : integer;
  S : string;
  Obj : TWSHyperlink;
  Elem : TRtfElement;
  Wrd : string;
  Parm : integer;
  Instr, Rslt : Boolean;
  Ind1, Ind2 : integer;
  Scp : integer;
  N : integer;
  i : integer;
begin
      Obj := nil;
      with ReadInfo do
      begin
         BraceCount := 1;
         {Init the bracecounter as this will tell us when we are at end of the
         field group}
         Instr := False; {True whe the "fldinst" group is in focus}
         Rslt := False; {True whe the "fldrslt" group is in focus}
         Scp := 0; {Length of the hyperlink text. To be processed later}
         if Reader.ReadUndo then
         {If a property undo operation is active, pick up the object to be undone.
         In fact this will never happen for the hyperlink, as this implementation has
         no properties that creates undo information}
         begin
           {This test because the InternalLink class also calls this method. This
           is a local solution, and it should be removed when creating a
           clear cut hyperlink object}
           if ClassType = TWSHyperlink then
             Obj := Reader.UndoObject as TWSHyperLink
           else
             Obj := Reader.UndoObject as TWSInternalLink
         end
         else
         begin
           if ClassType = TWSHyperlink then
             Obj := TWSHyperlink.Create(Owner, 0)
           else
             Obj := TWSInternalLink.Create(Owner, 0, nil);
           {Create a new object}
         end;
         S := Reader.GetNextElement(Elem);
         {Start the rtf-element loop to examine the elements to be handled}
         while (BraceCount <> 0) and (Elem <> reEof) do
         begin
             if (Elem in [reData, reEscape]) then
             {Process text}
             begin
                 if Instr then
                 {If we are processing the field instruction group, data
                 contains the kind of field and the target:}
                 begin
                    Ind1 := Pos('"', S);
                    for i := Ind1+1 to Length(S) do
                      if S[i] = '"' then
                      begin
                         Ind2 := i;
                         Break;
                      end;
                    Obj.FTarget := Copy(S, Ind1 + 1, Ind2 - Ind1-1);
                    Instr := False;
                 end
                 else if Rslt then
                 {If we are processing the field result group, data
                 contains the hyperlink text. Normally this group would
                 have been handled by the WS kernel, but as we need to calculate
                 the length of the text, the object will take care of it with
                 a little help from the reader}
                 begin
                   if (Elem = reEscape) and (Length(S) = 2) then
                   {Escape characters must be stored as 8 bit values}
                   begin
                       N := StrToInt('$' + S);
                       Reader.AddText(Chr(N));
                       Inc(Scp, 1);
                   end
                   else
                   begin
                     Reader.AddText(S);
                     {This ensures that the text gets into the textbuffer}
                     Inc(Scp, Length(S));
                     {Increment length}
                   end;
                 end;
             end
             else if (Elem = reCtrlWord) then
             {Process controlword}
             begin
                if Rslt then
                {If we are processing the field result group, text attributes
                and other commands applies to the hyperlink text.}
                begin
                  {Forward the ctrl word to the reader for processing by the ws kernel}
                  Reader.SplitCtrlWord(S, Wrd, Parm);
                  if (Parm = 0) and (Pos('0', S)= 0) then
                  {If the controlword has no parameter, set it as blank,
                  else the formatting result might not be correct}
                    Reader.ActOn(Wrd, '')
                  else
                   Reader.ActOn(Wrd, IntToStr(Parm));
                end
                else if S = 'fldinst' then
                {Field instructions}
                  Instr := True
                else if S = 'fldrslt' then
                {Result text}
                  Rslt := True;
                if Reader.StartGroup then
                {if the controlword starts a new group, there is an
                implicit open brace that must be counted for}
                  Inc(BraceCount);
             end
             else if Elem = reCloseBrace then
             {Process braces}
             begin
                 Dec(BraceCount);
                 Reader.PullStack;
             end
             else if Elem = reOpenBrace then
             begin
                Inc(BraceCount);
                Reader.PushStack;
             end;
             if BraceCount <> 0 then
               S := Reader.GetNextElement(Elem);
         end;
         {Set scope = the accumulatedated length of the hyperlink text}
         Obj.Scope := Scp;
      end;

      {Add object to temporary buffer, but only if it is a new object. If
      RedRtf is called as part of a property undo operation, the
      modifications are done directly on the exisiting object, and
      it will be no need to add it to the object list.}

      if not Reader.ReadUndo and (Obj <> nil) then
        Reader.AddObjectToBuffer(Obj, ReadInfo.Index, -1);
      Result := Obj;
end;

constructor TWSHyperlink.Create(AnOwner : TWordSource; InitialScope : integer);
begin
     inherited Create(AnOwner, InitialScope);
     FStyle := [hsStaticUnderline, hsShowVisited];
     FUnderlined := True;
end;

procedure TWSHyperlink.ApplyAttributes;
{This method sets the hyperlink attributes. The inherted method simply
applies the Attribute property, this is not good enough for our purpose
so we have to override it.}
var
  Attr : TAttributes;
begin
    begin
        Attr := Owner.DefAttributes;
        with Attr do
        begin
             {Set color according to Style and Visited}
             if not (hsShowVisited in Style) or not FVisited then
              FontColor := clBlue
             else
               FontColor := clMaroon;
             {Set underlining according to style and the Underline flag}
             if (hsStaticUnderline in Style) and Underlined then
             {Always underline whe static underlining}
             begin
               FontStyle := [fsUnderLine];
               Owner.MergeAttributes(Attr, [caFontColor, caUnderline], TextRange);
             end
             else if Underlined then
             {Dynamic underlining. Remove underline. The MouseMoving method will
             control the Style type }
             begin
               Attr.FontStyle := [];
               Owner.MergeAttributes(Attr, [caFontColor, caUnderline], TextRange);
             end
             else
               {Not underlined. Set color only}
               Owner.MergeAttributes(Attr, [caFontColor], TextRange);
        end;
    end;
end;

{TWSInternalLink ------------------------------------------------------------
Navigates internally}

constructor TWSInternalLink.Create(AnOwner : TWordSource;
  InitialScope : integer; ParentApp : TfrmHoved);
begin
    inherited Create(AnOwner, InitialScope);
    FApp := ParentApp;
end;

procedure TWSInternalLink.MousePressed(Button : TMouseButton; Shift : TShiftState; X, Y : integer;
var Cursor : TCursor; var StartSize : Boolean);
var
  Trg : integer;
begin
     if (Button <> mbLeft) then
       Exit;
     if Shift <> [ssLeft] then
       Exit;
     Trg := StrToInt(Target);
     PostMessage(App.Handle, wm_ChangeScreen, Trg, 0);
end;

function TWSInternalLink.ReadRtf(Reader : TRtfRead; ReadInfo : TReadInfo) : TWSObject;
var
  S : string;
begin
      Result := inherited ReadRtf(Reader, ReadInfo);
      if Result <> nil then
        Exit;

      with ReadInfo do
      if (ACtrlWord = 'field') then
      begin
         S := Reader.FindSubGroup('fldinst');
         if Pos('INTERNALLINK "', S) = 0 then
           Exit;
         Result := CreateLinkObject(Reader, ReadInfo);
         if result <> nil then
           TWSInternalLink(Result).FApp := App;
      end;
end;

function TWSInternalLink.CanReadGroup(ACtrlWord : string; Reader : TrtfRead) : Boolean;
var
  S : string;
begin
   Result := False;
   if (ACtrlWord = 'field') then
   begin
      S := Reader.FindSubGroup('fldinst');
      if Pos('INTERNALLINK "', S) = 0 then
        Exit;
   end;
   Result := (ACtrlWord = 'field') or (ACtrlWord = 'fldinst') or (ACtrlWord = 'fldrslt');
end;

function TWSInternalLink.WriteRtf(Writer : TRtfWrite; WriteInfo : TWriteInfo) : string;
begin
    Result := inherited WriteRtf(Writer, WriteInfo);
    if (Result <> '') then
      Exit;
    Result := '{\field {\*\fldinst INTERNALLINK "' + FTarget + '" }' +
    '{\fldrslt ' + WriteInfo.ResultText + '}}';
end;

{----------------------------------------------------------------------------}

procedure TfrmHoved.WMChangeScreen(var Message : TMessage);
begin
   FCurScreen := Message.WParam;
   SetScreen(Message.WParam);
   ws.Selstart := 0;
end;

procedure TfrmHoved.SetDelphiKeyStrings;
{Loads the Delphi keystring list}
var
  i : integer;
begin
   with ws do
   begin
       Keystrings.Clear;
       for i := 1 to DKeyStrCount do
       begin
           KeyStrings.Add(DelphiKeystrings[i])
       end;
       Markers.Clear;
       Markers.Add('{');
       Markers.Add('}');
       Markers.Add('//');
       Markers.Add('<EOL>');
   end;
end;

procedure TfrmHoved.InvalidatePB;
var
  R : TRect;
begin
      R.Left := pb.Left;
      R.Top := pb.Top;
      R.Right := pb.Left + pb.Width;
      R.Bottom := pb.Top + pb.Height;
      InvalidateRect(pb.Parent.Handle, @R, False);
end;

function TfrmHoved.GetFiRect : Trect;
{Compute sthe rectangle of the FirstIndent slider}
var
  Para : TWSParagraph;
begin
  with Result do
  begin
     Para := ws.ParaAttributes[ws.CurrentParaNumber];
     with Para do
     begin
        Left := ws.LeftMargin + FirstIndent + LeftIndent + 1;
        Right := Left + 10;
        Top := pb.ClientRect.Top;
        Bottom := Top + 10;
     end;
  end;
end;

function TfrmHoved.GetLiRect : Trect;
{Compute sthe rectangle of the LeftIndent slider}
var
  Para : TWSParagraph;
begin
  with Result do
  begin
     Para := ws.ParaAttributes[ws.CurrentParaNumber];
     with Para do
     begin
        Left := ws.LeftMargin + LeftIndent + 1;
        Right := Left + 10;
        Top := pb.ClientRect.Top + 20;
        Bottom := Top + 10;
     end;
  end;
end;

function TfrmHoved.GetHangRect : Trect;
{Compute sthe rectangle of the "hanging indent" slider}
var
  Para : TWSParagraph;
begin
  with Result do
  begin
     Para := ws.ParaAttributes[ws.CurrentParaNumber];
     with Para do
     begin
        Left := ws.LeftMargin + LeftIndent + 1;
        Right := Left + 10;
        Top := pb.ClientRect.Top + 10;
        Bottom := Top + 10;
     end;
  end;
end;

function TfrmHoved.GetRiRect : Trect;
{Compute sthe rectangle of the RightIndent slider}
var
  Para : TWSParagraph;
begin
  with Result do
  begin
     Para := ws.ParaAttributes[ws.CurrentParaNumber];
     with Para do
     begin
        Left := ws.PageRect.Right - Para.RightIndent-10;
        Right := Left + 10;
        Top := pb.ClientRect.Top + 20;
        Bottom := Top + 10;
     end;
  end;
end;

procedure TfrmHoved.SetStyle(Include : Boolean; Style : TFontStyle);
{Sets fontstyle for the current selection. If Include the styles are
to be merged with the current styles in selection}
var
  Fmts : TList;
  Attr : TAttributes;
  Filtr : TAttributeFilter;
  Cnt : integer;
begin
     Attr := ws.DefAttributes;
     Fmts := ws.FindAttributes(ws.SelRange, False);
     {Get current attributes in selection}
     Cnt := Fmts.Count;
     ClearLocations(Fmts, True);
     if (Cnt = 0) and Include then
     begin
          {No attributes. No need for merging}
          Attr.FontStyle := [Style];
          ws.SetSelAttributes(Attr);
     end
     else
     begin
          if Include then Attr.FontStyle := [Style];
          case Style of
            fsBold : Filtr := [caBold];
            fsItalic: Filtr := [caItalic];
            fsUnderline: Filtr := [caUnderline];
            fsStrikeOut : Filtr := [caStrikeOut];
          end;
          ws.MergeSelAttributes(Attr, Filtr);
     end;
end;

function TfrmHoved.FontToAttributes(AFont : TFont) : TAttributes;
{Converts a TFont to a TAttributes record}
begin
   Result := ws.DefAttributes;
   with Result do
   begin
        FontName := AFont.Name;
        FontSize := AFont.Size;
        FontCharset := AFont.Charset;
        FontStyle := AFont.Style;
        FontColor := AFont.Color;
   end;
end;

procedure TfrmHoved.ac_BoldExecute(Sender: TObject);
begin
    ac_Bold.Checked := not ac_Bold.Checked;
    SetStyle(ac_Bold.Checked, fsBold);
end;

procedure TfrmHoved.ac_ItalicExecute(Sender: TObject);
begin
      ac_Italic.Checked := not ac_Italic.Checked;
      SetStyle(ac_Italic.Checked, fsItalic);
end;

procedure TfrmHoved.ac_UnderlineExecute(Sender: TObject);
begin
      ac_Underline.Checked := not ac_Underline.Checked;
      SetStyle(ac_Underline.Checked, fsUnderline);
end;

procedure TfrmHoved.ac_FontExecute(Sender: TObject);
{Calls the font dialog and sets compound attributes for the selected area}
var
  Attr : TAttributes;
begin
  with FontDialog1.Font do
  begin
       {Initialize the font dialog}
       Attr := ws.AttributesOfIndex(ws.Selstart);
       Name := Attr.FontName;
       Size := Attr.FontSize;
       Style := Attr.FontStyle;
       CharSet := Attr.FontCharset;
       Color := Attr.FontColor;
  end;
  if FontDialog1.Execute then
  begin
      Attr := ws.DefAttributes;
      with Attr do
      begin
            with FontDialog1 do
            begin
               FontName := Font.Name;
               FontSize := Font.Size;
               FontStyle := Font.Style;
               FontCharSet := Font.Charset;
               FontColor := Font.Color;
            end;
      end;
      ws.SetSelAttributes(Attr)
  end;
end;

procedure TfrmHoved.ac_OpenExecute(Sender: TObject);
begin
     if OpenDialog1.Execute then
     begin
       Update;
       if (FCurScreen <> 4) then
       begin
            SetScreen(-1);
            FCurScreen := -1;
       end;
       ws.LoadFromFile(OpenDialog1.FileName, nil);
       Caption := OpenDialog1.FileName;
     end;
end;

procedure TfrmHoved.FormCreate(Sender: TObject);
begin
     {Register the linkobjects so they may be read from a file or the clipboard}
     ws.RegisterTWSObject(TWSHyperlink.Create(ws, 0));
     ws.RegisterTWSObject(TWSInternallink.Create(ws, 0, Self));

     WindowState := wsMaximized;
     ws.PrintPageToScreenPage;
     {Sets PaperHeight and PaperWidth.
     Reads printer mode and converts paper height and paper width to screen pixels}

     FLandscape := TBitmap.Create;
     FLandscape.LoadFromFile('Lake.bmp');
     {Loads the Nordic lake}

     mem_Keystrings.Lines.Assign(ws.KeyStrings);
     mem_Markers.Lines.Assign(ws.Markers);
     mem_Keystrings.Font.Assign(ws.KeystringFont);
     mem_Markers.Font.Assign(ws.MarkupFont);
     cbx_Single.Checked := (qtSingle in ws.Quotes);
     cbx_Dbl.Checked := (qtDouble in ws.Quotes);
     {Preparing the AutoFormat demo}

     FOrigAttributes := ws.DefAttributes;
     SetScreen(0);
     {Displays initial demo screen}
end;

procedure TfrmHoved.ac_FindExecute(Sender: TObject);
begin
    FindDialog1.Execute;
    ws.HideSelectOptions := soHideNever;
end;

procedure TfrmHoved.FindDialog1Find(Sender: TObject);
var
  P : integer;
begin
  P := ws.FindText(FindDialog1.FindText, ws.Selstart+1, (frMatchCase in FindDialog1.Options),
  (frWholeWord in FindDialog1.Options));
  if P <> -1 then
  begin
    ws.SelStart := P;
    ws.SelLength := Length(FindDialog1.FindText);
  end
  else
    ShowMessage('Not found.');
end;

procedure TfrmHoved.ac_PrintExecute(Sender: TObject);
begin
   ws.Print(-1, -1, False);
end;

procedure TfrmHoved.ac_SaveUpdate(Sender: TObject);
begin
    ac_Save.Enabled := ws.Modified;
end;

procedure TfrmHoved.ac_SaveExecute(Sender: TObject);
begin
     if FileExists(Caption) then
       ws.SaveToFile(Caption, ws.RTFSaver)
     else if SaveDialog1.Execute then
     begin
         ws.SaveToFile(Savedialog1.FileName, ws.RTFSaver);
     end;
end;

function SortProc(Item1, Item2 : Pointer) : integer;
{Used with the Draw screen demo to sort keystring instances}
var
  SL1, SL2 : TStringLocation;
begin
    SL1 := TStringLocation(Item1^);
    SL2 := TStringLocation(Item2^);
    if Sl1.Range.Index > Sl2.Range.Index then
      Result := 1
    else if Sl1.Range.Index < Sl2.Range.Index then
      Result := -1
    else
      Result := 0;
end;

procedure TfrmHoved.wsDrawScreen(Sender: TObject; Canvas: TCanvas);
{Drawing different effects, depending on the active demo screen}
var
  i, j : integer;
  R : TRect;
  Loc1, Loc2 : PStringLocation;
  StPoint, NdPoint : TPoint;
  P : integer;
  LVisbl, CVisbl : Boolean;
  Cnt : integer;
  x : integer;

begin
  if (FCurScreen = 2) and (FKeyStrList <> nil) then
  begin
       {Draw screen demo}
       if FKeyListDirty then
       begin
            {If text is edited, the keystringlist must be rebuilt}
            ClearLocations(FKeystrList, True);
            FKeyStrList := ws.FindKeyStrings(ToRange(0, -1));
            FKeyStrList.Sort(SortProc);
            FKeylistDirty := False;
       end;

       {Connect begin/end pairs}
       x := 0;
       Cnt := FKeystrList.Count;
       for i := 0 to Cnt - 1 do
       begin
         inc(X);
         Loc1 := FKeyStrList[i];
         if Loc1^.TheString = 'BEGIN' then
         begin
           P := 1;
           j := i+1;

           while (P <> 0) and (j < Cnt) do
           begin
             Loc2 := FKeyStrList[j];
             if Loc2^.TheString = 'BEGIN' then
              Inc(P)
             else if Loc2^.TheString = 'END' then
              Dec(P);
             inc(j);
             inc(X);
           end;

           Canvas.Pen.Color := clGreen;
           if P = 0 then
           begin
               StPoint := ws.IndexToPoint(Loc1^.Range.Index);
               NdPoint := ws.IndexToPoint(Loc2^.Range.Index);
               R := ws.RangeRect[Loc2.Range];
               if R.Bottom <> 0 then
                 NdPoint.Y := R.Bottom;
               R := ws.PageRect;
               if NdPoint.Y > R.Bottom then
                 NdPoint.Y := R.Bottom
               else if NdPoint.Y < R.Top then
                 NdPoint.Y := R.Top;

               if StPoint.Y > R.Bottom then
                 StPoint.Y := R.Bottom
               else if NdPoint.Y < R.Top then
                 StPoint.Y := R.Top;


               if StPoint.X <= NdPoint.X then
               begin
                 Canvas.MoveTo(StPoint.X-2, StPoint.Y);
                 ws.IndexVisible(Loc1^.Range.Index, LVisbl, CVisbl);
                 if LVisbl then
                 begin
                   Canvas.LineTo(StPoint.X+5, StPoint.Y);
                   Canvas.MoveTo(StPoint.X-2, StPoint.Y);
                 end;
                 Canvas.LineTo(StPoint.X-2, NdPoint.Y);
                 ws.IndexVisible(Loc2^.Range.Index, LVisbl, CVisbl);
                 if LVisbl then
                  Canvas.LineTo(StPoint.X+5, NdPoint.Y);
               end
               else
               begin
                 Canvas.MoveTo(NdPoint.X-2, StPoint.Y);
                 ws.IndexVisible(Loc1^.Range.Index, LVisbl, CVisbl);
                 if Lvisbl then
                 begin
                   Canvas.LineTo(NdPoint.X+5, StPoint.Y);
                   Canvas.MoveTo(NdPoint.X-2, StPoint.Y);
                 end;
                 Canvas.LineTo(NdPoint.X-2, NdPoint.Y);
                 ws.IndexVisible(Loc2^.Range.Index, LVisbl, CVisbl);
                 if LVisbl then
                   Canvas.LineTo(NdPoint.X+5, NdPoint.Y);
               end;
           end;
         end;
       end;

  end;

  {If user is sliding the indent-knobs redraw then marker line}
  if FRulerMode <> rmNoIndent then
  begin
       Canvas.Pen.Width := 1;
       Canvas.Pen.Color := clBlue;
       Canvas.MoveTo(FRulerX, ws.ClientRect.Top);
       Canvas.LineTo(FRulerX, ws.ClientRect.Bottom);
  end;
end;

procedure TfrmHoved.wsAutoFormat(Sender: TObject;
  KeyStringKind: TKeyStringKind; var TheString: String; var Range: TRange;
  var Attributes: TAttributes);
{Finetunes formatting of keytext}
var
  L, C : integer;
begin
  if (TheString = 'PROCEDURE') or (TheString = 'FUNCTION') then
     Attributes.FontColor := clRed;
  if (KeyStringKind = ksRangeMarker) and (FCurScreen = 2) then
  begin
    ws.LineColfromIndex(Range.Index, L, C);
    if L in [0..11] then
    {The ingress of the AutoFormat demo. Not too safe...}
    begin
         Attributes.FontName := 'Arial';
         Attributes.FontSize := 11;
         Attributes.FontColor := clBlack;
         Attributes.FontStyle := [fsBold];
    end;
  end;
  if TheString = 'HOME' then
  begin
      Attributes.FontName := 'Arial';
      Attributes.FontSize := 12;
      Attributes.FontColor := clBlue;
      Attributes.FontStyle := [fsUnderline];
  end;
end;

procedure TfrmHoved.wsSelChange(Sender: TObject);
var
  ALine, ACol : integer;
  Rct : TRect;
  PT : TPoint;
  Attr : TAttributes;
begin
  e_Footnote.Text := '';
  with StatusBar1, ws do
  begin
        {Update info on statusline, according to selstart position.
        If Winhelp demo is active update the Linker window it it is created}
        LineColFromIndex(CaretPos, ALine, ACol);
        SimpleText := 'Line: ' + IntTosTr(ALine+1) + ' Column: ' + IntToStr(ACol+1) +
        ' Index: ' + IntToStr(Selstart) +
        ' Para: ' + IntToStr(CurrentParanumber);

        PT := ws.IndexToPoint(ws.Selstart);
        Simpletext := Simpletext + ' X: ' + IntTostr(PT.X) + ' Y: ' + IntTostr(PT.Y);
        Attr := AttributesOfIndex(Selstart);
        ac_Bold.Checked := (fsBold in Attr.FontStyle);
        ac_Italic.Checked := (fsItalic in Attr.FontStyle);
        ac_Underline.Checked := (fsUnderline in Attr.FontStyle);
        if Assigned(frmJumper) then
        begin
          if (Sellength > 0) and (SelLength < 50) then
            frmJumper.lbl_Word.Caption := SelText
          else
            frmJumper.lbl_Word.Caption := CurrentWord;
        end;
  end;

  if FCurScreen = 2 then
  begin
      {Draw screen demo. Need to redraw page content beacuse of the highlight line feature}
      Rct := ws.Pagerect;
      Rct.Left := 0;
      InvalidateRect(ws.Handle, @Rct, False);
      {Alway set redraw flag to false to keep the screen from flickering}
  end;
  InvalidatePB;
  {Update ruler}

  FCurrentFootNote := nil;
end;


procedure TfrmHoved.SetScreen(ScreenNo : integer);
{Displays the different demo screens}
var
  Attr : TAttributes;
  FontName : string;
  Selst : integer;

  function SetLinkStyle(Targ : string; Scope : integer) : TWSInternalLink;
  {Creates a hyperlink-like attribute}
  var
    Obj : TWSInternalLink;
  begin
      if ws.Mode = moNoObjects then
        Exit;
      Obj := TWSInternalLink.Create(ws, Scope, Self);
      Obj.Target := Targ;
      ws.AddTWSObject(Obj, Selst, 0);
      Result := Obj;
  end;

  procedure SetNormalStyle;
  begin
      Attr.FontSize := 12;
      Attr.FontStyle := [];
      Attr.FontColor := clBlack;
      Attr.FontName := FontName;
      ws.SetSelAttributes(Attr);
  end;


  procedure Set0;
  {Intro screen. This screen is built entierly by prgrammatcial means}
  var
    Obj : TWSParagraph;
    ObjGr : TWSGraphic;
  begin
       with ws do
       begin

           if MethodIcon <> nil then
             FreeAndNil(MethodIcon);
           ws.AutoFormat := False;
           LeftMargin3D := False;
           LeftMarginColor := clWhite;
           RightMargin := MillimetersToPoints(25, True);
           LeftMargin := RightMargin;
           Pan_Auto.Visible := false;

           TypeText('Welcome to WordSource!');
           Attr.FontSize := 17;
           Attr.FontStyle := [fsBold, fsItalic];
           SetTextAttributes(Attr, ToRange(0, TextBuf.TBLength));
           TypeText(LB);

           Attr.FontSize := 8;
           Attr.FontStyle := [];
           Attr.FontColor := clBlue;
           Attr.FontName := 'Arial';
           SetSelAttributes(Attr);

           if Mode = moObjects then
           begin
             ObjGr := TWSGraphic.Create(ws);
             ObjGr.PictureType := pt_Bitmap;
             ObjGr.BitmapPicture.Assign(FLandscape);
             ws.AddTWSObject(ObjGr, Selstart, -1);
           end;

           TypeText(LB);
           TypeText('Nordic lake');
           SetNormalStyle;
           TypeText(LB+LB);
           TypeText('TWordSource is a powerfull edit component with a lot of possibilites: Text formatting, graphics, ' +
           'bulleted and numbered lists along with many other paragraph features. ');

           Attr.FontStyle := [fsUnderline];
           SetSelAttributes(Attr);
           TypeText('AutoFormat');
           SetNormalStyle;

           TypeText(' is something of its own, letting you format keywords, phrases, comments, etc. with very little coding. ' +
            'The power of the ');
           Attr.FontStyle := [fsUnderline];
           SetSelAttributes(Attr);
           TypeText('TWSObject');
           SetNormalStyle;
           TypeText(' concept even allows you to enhance RTF-capabilites.' + LB + LB);

           TypeText('Try it out on your own, but first take a short tour to learn some essensials about the component.');

           TypeText(LB+LB);

           {Start bullet list}
           if Mode = moObjects then
           begin
             Obj := EditParagraph(CurrentParaNumber);
             Obj.BeginChange;
             Obj.Numbering := pnStar;
             Attr := Obj.NumberAttr;
             Attr.FontColor := clRed;
             Obj.NumberAttr := Attr;
             Obj.LeftIndent := 48;
             Obj.FirstIndent := -48;
             Obj.EndChange;
           end;

           Selst := ws.Selstart;
           TypeText('Using AutoFormat');
           SetLinkStyle('1', length('Using AutoFormat'));
           SetNormalStyle;
           TypeText('. With simple means you can make TWordSource format keywords, ' +
             'marked areas, quotes and other text elements.');
           TypeText(LS + LB);

           Selst := ws.SelStart;
           TypeText('Draw on the screen.');
           SetLinkStyle('2', length('Draw on the screen.'));
           SetNormalStyle;
           TypeText('. See how to use draw-events to achieve effects.');
           TypeText(LS + LB);

           Selst := ws.SelStart;
           TypeText('Using TWSObjects');
           SetLinkStyle('3', Length('Using TWSObjects'));
           SetNormalStyle;
           TypeText('. Embed graphics and other elements into the text .' + LS + LB);

           Selst := ws.SelStart;
           TypeText('Blank page');
           SetLinkStyle('-1', Length('Blank page'));
           SetNormalStyle;
           TypeText('. Do what you like.' + LB);

           {End bullet list by overwrite the last bullet with default para attributes}
           ParaAttributes[CurrentParaNumber] := DefParaAttributes;

           TypeText(LB+LB);
           Attr := DefAttributes;
           Attr.FontStyle := [fsItalic];
           Attr.FontColor := clGreen;

           if Mode = moObjects then
           begin
             Obj := EditParagraph(CurrentParaNumber);
             Obj.LeftIndent := 400;
           end;
           SetSelAttributes(Attr);
           TypeText('Click on a link to activate a demo screen.');
       end;
  end;

  procedure Set1;
  {AutoFormat demo}
  begin
    with ws do
    begin
         if MethodIcon <> nil then
            FreeAndNil(MethodIcon);
         Keystrings.Assign(mem_KeyStrings.Lines);
         Markers.Assign(mem_Markers.Lines);
         Pan_Auto.Visible := True;
         Attr.FontSize := 17;
         Attr.FontStyle := [fsBold, fsItalic];
         SetSelAttributes(Attr);
         TypeText('Using AutoFormat');
         SetNormalStyle;
         TypeText(LB+LB);
         TypeText('The text below is taken from the TWordSource help file.' + LB+LB);

         Attr.FontSize := 10;
         Attr.FontStyle := [];
         SetSelAttributes(Attr);

         TypeText('To understand how AutoFormat works you should be familiar with the terms Keystrings, Markers and Quotes.' + LB + LB);

         TypeText('A keystring is a text string you want to be formatted in some way. Keystrings can be literals  containing ' +
          'any characters, or placeholders. Placeholders are of 2 kinds: Number and Tag. The number placeholders ' +
          'consider any number as a keystring, the tag placeholder recognize any text between (and including) a start ' +
          'tag and an end tag as a keystring. All keystrings are line related, i.e. if a tag spans multiple lines ' +
          'it is not recognized as a tag.' + LB + LB);

         TypeText('/*A marker is a combination of maximum three characters that delimits a text area. You define a startmarker ' +
          'and an endmarker. Markers can be rangemarkers or linemarkers. Rangemarkers cover multiple lines, while' +
          'linemarkers cover only one line. All text within and including a marker pair (EOL ends a linemarker) can ' +
          'be formatted in some way.*/' + LB + LB);

         TypeText('''' + 'Quotes' + '''' + ' are either "double" or single. They exist only within a line. ' +
          '''' + 'A none terminated start quote is considered to work through the rest of the line. ' +
          'Text within a quoted area including the quotes can be formatted in some way.' + LB);

         SetNormalStyle;
         Typetext(LB);

         TypeText('At left you see a list of keystrings (on top) and markers and the quote definitions ' +
          'Try them out by pressing the ');
         Attr.FontStyle := [fsBold];
         SetSelAttributes(Attr);
         Typetext('AutoFormat');
         SetNormalStyle;
         TypeText(' button. Then edit the text or the keystring-, ' +
          'markers- and quote definitions and see what happens.');

    end;
  end;

  procedure Set2;
  {Draw screen demo}
  var
    Attr : TAttributes;
    Rng : Trange;
  begin
      with ws do
      begin
           Pan_Auto.Visible := False;
           LeftMarginColor := clBtnFace;
           LeftMargin3D := True;
           LeftMargin := 40;
           Attr := DefAttributes;
           with Attr do
           begin
               FontSize := 10;
               Fontname := 'Courier New';
           end;
           DefAttributes := Attr;
           Keystrings.Clear;
           KeyStrings.Add('function');
           KeyStrings.Add('procedure');
           KeyStrings.Add('begin');
           KeyStrings.Add('end');
           KeyStrings.Add('home');
           Markers.Clear;
           Markers.Add('{');
           Markers.Add('}');
           DetectStrings := True;
           AutoFormat := True;
           LoadFromFile('FindQuoted.txt', nil);
           Rng.Index := 0;
           Rng.Length := -1;
           MethodIcon := TBitMap.Create;
           FKeyStrList := FindKeyStrings(Rng);
      end;
  end;

  procedure Set3;
  {Using TWSObjects}
  begin
       if MethodIcon <> nil then
            FreeAndNil(MethodIcon);
       ws.RightMargin := ws.MillimetersToPoints(25, True);
       ws.LeftMargin := ws.RightMargin;
       ws.AutoFormat := False;
       ws.LeftMargin3D := False;
       ws.LeftMarginColor := clWhite;
       Pan_Auto.Visible := false;
       ws.LoadFromFile('UsingTWSObjects.rtf', nil);
  end;

  procedure Set4;
  {Winhelp}
  begin
       if MethodIcon <> nil then
            FreeAndNil(MethodIcon);
       ws.RightMargin := ws.MillimetersToPoints(25, True);
       ws.LeftMargin := ws.RightMargin;
       ws.AutoFormat := False;
       ws.LeftMargin3D := False;
       ws.LeftMarginColor := clWhite;
       Pan_Auto.Visible := false;
       PanFootnote.Visible := True;
       ws.LoadFromFile('WinHelpDemo.rtf', nil);
  end;

begin
  with ws do
  begin
        Clear;
        ws.DefAttributes := FOrigAttributes;
        FontName := Font.Name;
        panFootnote.Visible := False;
        if Assigned(frmJumper) and frmJumper.Visible then
          frmJumper.Hide;
        if ScreenNo = -1 then
        begin
          AutoFormat := False;
          RightMargin := ws.MillimetersToPoints(25, True);
          LeftMargin := ws.RightMargin;
        end;
        Attr := DefAttributes;
        case ScreenNo of
         0: Set0;
         1: Set1;
         2: Set2;
         3: Set3;
         4: Set4;
        end;
        ws.Modified := False;
        ws.ClearUndo;
  end;
end;

procedure TfrmHoved.FormDestroy(Sender: TObject);
begin
   FLandscape.Free;
   if MethodIcon <> nil then
     MethodIcon.Free;
end;

procedure TfrmHoved.ac_AutoFormatExecute(Sender: TObject);
{Changes to autoformat mode when clicking the AutoFormat button in the
auto format demo screen}
begin
    with ws do
    begin
      KeyStrings.Assign(mem_Keystrings.Lines);
      if AutoFormat then
        RefreshAutoformats
      else
        AutoFormat := True
    end;
end;

procedure TfrmHoved.SpeedButton5Click(Sender: TObject);
{Reset to normal mode when clicking the Reset Screen button in the
auto format demo screen}
begin
  ws.AutoFormat := False;
  SetScreen(1);
end;

procedure TfrmHoved.mem_KeyStringsChange(Sender: TObject);
{Runs an autoformat search when the keystring lists have been changed in
then auto format demo screen}
var
 HasBlanks : Boolean;
 i : integer;
begin
    if ws.AutoFormat then
    begin
      ws.KeyStrings.Assign(mem_Keystrings.Lines);
      if not Odd(mem_Markers.Lines.Count) then
      begin
        HasBlanks := False;
        for i := 0 to mem_Markers.Lines.Count -1 do
        begin
             HasBlanks := (Trim(mem_Markers.Lines[i]) = '');
             if HasBlanks then
               Break;
        end;
        if not HasBlanks then
          ws.Markers.Assign(mem_Markers.Lines);
      end;
      ws.RefreshAutoFormats;
    end;
end;

procedure TfrmHoved.cbx_SingleClick(Sender: TObject);
{Runs an autoformat search when the quote defintions hav been changed in
then auto format demo screen}
begin
      if not ws.AutoFormat then exit;
      if cbx_Single.Checked then
        ws.Quotes := ws.Quotes + [qtSingle]
      else
        ws.Quotes := ws.Quotes - [qtSingle];
      ws.RefreshAutoFormats;

end;

procedure TfrmHoved.cbx_DblClick(Sender: TObject);
{Runs an autoformat search when the quote defintions hav been changed in
then auto format demo screen}
begin
      if not ws.AutoFormat then exit;
      if cbx_Dbl.Checked then
        ws.Quotes := ws.Quotes + [qtDouble]
      else
        ws.Quotes := ws.Quotes - [qtDouble];
      ws.RefreshAutoFormats;

end;

procedure TfrmHoved.sb_KSAttrClick(Sender: TObject);
{Runs the font dialog to change keystring attributes definitions}
begin
    if FontDialog1.Execute then
    begin
           if Sender = sb_KsAttr then
           begin
              ws.KeyStringFont.Assign(FontDialog1.Font);
              mem_Keystrings.Font.Assign(FontDialog1.Font);
           end
           else if Sender = sb_MrkAttr then
           begin
              ws.MarkupFont.Assign(FontDialog1.Font);
              mem_Markers.Font.Assign(FontDialog1.Font);
           end
           else
           begin
               ws.QuoteColor := FontDialog1.Font.Color;
               ws.QuoteStyle := FontDialog1.Font.Style;
           end;
           ws.RefreshAutoFormats;
    end;
end;

procedure TfrmHoved.ac_ClearExecute(Sender: TObject);
{Runs the Clear command}
begin
  ws.Clear;
  Caption := 'WordSource demo';
  FCurScreen := -1;
end;

procedure TfrmHoved.wsDrawLine(Sender: TObject; Canvas: TCanvas;
  LeftMarginRect, LineRect: TRect; LineNumber: Integer; Selection: TRange;
  var FormatOptions: TFormatOptions; var DefaultDraw: Boolean);
{Responds to the OnDrawLine event, according to the active demo screen}
var
  S : string;
  P : integer;
  Indx : integer;
  IsFunc, Isproc : Boolean;
  PNum, Offs : integer;
begin
    DefaultDraw := True;
    Offs := -1;
    Indx := ws.IndexFromLineCol(LineNumber, 0);
    ws.ParaFromIndex(Indx, PNum, Offs);
    if (ws.Mode = moObjects) and ws.ParaAttributes[PNum].KeepWithNext then
    begin
         Canvas.Font.Name := 'Arial';
         Canvas.Font.Style := [fsBold];
         Canvas.Font.Size := 10;
         Canvas.Font.Color := clRed;
         Canvas.TextOut(LeftMarginrect.Left + 3, LeftMarginRect.Top + 3, '>');
    end;

    if FCurScreen <> 2 then
      Exit;
    {Only the Draw screen demo takes part in this event}

    if LineNumber = ws.CurrentLineNumber then
    {Set line format options for the line that sontains selstart}
    with FormatOptions do
    begin
        BGColor := clInactiveCaptionText;
        {Background color for line}
        Pad := True;
        {Pad color til right margin}
    end;
    with Canvas do begin
        {Print linenumber}
        Font.Assign(ws.Font);
        Font.Size := 8;
        Brush.Color := clBtnFace;
        if LineNumber = ws.CurrentLineNumber then
        begin
          Font.Style := [fsBold];
          Font.Size := 10;
        end;
        TextOut(LeftMarginRect.Left + 1, LeftMarginrect.Top + 1, IntTostr(LineNumber + 1));
        IsFunc := False;
        IsProc := False;

        {Draw symbol for proc/function on the left margin}
        S := ws.TextBuf.Lines[LineNumber];
        P := Pos('FUNCTION', Uppercase(S));
        IsFunc := (P <> 0);
        if IsFunc then
        begin
          Indx := ws.IndexFromLineCol(LineNumber, 0) + P;
          IsFunc := not ws.IsIndexMarked(Indx) and not ws.IsIndexQuoted(Indx);
          {Don't draw anything if the text is marked or quoted}
        end;
        if not IsFunc then
        begin
            P := Pos('PROCEDURE', Uppercase(S));
            IsProc := (P <> 0);
            if IsProc then
            begin
             Indx := ws.IndexFromLineCol(LineNumber, 0) + P;
             IsProc := not ws.IsIndexMarked(Indx) and not ws.IsIndexQuoted(Indx);
            end;
        end;

        if IsFunc or IsProc then
        begin
             MethodIcon.Transparent := True;
             if IsFunc then
               Imagelist1.GetBitmap(9, MethodIcon)
             else
               Imagelist1.GetBitmap(8, MethodIcon);
             Canvas.Draw(LeftMarginRect.Right-MethodIcon.Width - 3, LeftMarginRect.Top + 1, MethodIcon);
        end;
    end;
end;

procedure TfrmHoved.wsAfterTextChange(Sender: TObject;
  ChangeKind: TTextChangeKind; Text: String; Range: TRange);
begin
   FKeyListDirty := True;
   InvalidatePB;
end;

{The following are menu access to demo screens}
procedure TfrmHoved.Intro1Click(Sender: TObject);
begin
  FCurScreen := 0;
  SetScreen(0);
end;

procedure TfrmHoved.Usingautoformat1Click(Sender: TObject);
begin
  FCurScreen := 1;
  SetScreen(1);
end;

procedure TfrmHoved.Workingwithgraphics1Click(Sender: TObject);
begin
  FCurScreen := 2;
  SetScreen(2);
end;

procedure TfrmHoved.FontDialog1Close(Sender: TObject);
begin
    ws.HideSelectOptions := soHideWhenInactive;
end;

procedure TfrmHoved.pbPaint(Sender: TObject);
{Managing the ruler. The ruler image is built offscreen to prevent flickering}
var
  TabWdth : integer;
  X, Y : integer;
  Para : TWSParagraph;
  i : integer;
  LastParaTab : integer;
  T, B : integer;
  R : TRect;
  BM : TBitmap;
  DiffX : integer;
  ScrBM : TBitMap;

  procedure DrawMetrics;
  var
   X : integer;
   CM : integer;
  begin
      X := R.Left;
      CM := 10;
      ScrBM.Canvas.Font.Color := clGray;
      with ScrBM.Canvas do
      {Print centimeters}
      repeat
           X := R.Left + ws.MillimetersToPoints(CM, true);
           if X >= R.Right - TextWidth(IntToStr(CM div 10)) then
             Break;
           MoveTo(X, R.Top);
           LineTo(X, R.Top + 9);
           Dec(X, TextWidth(IntToStr(CM div 10)) div 2);
           TextOut(X, R.Top+9, IntToStr(CM div 10));
           inc(Cm, 10);
      until False;
      CM := 5;
      with ScrBM.Canvas do
      {Print half centimeter markers}
      repeat
           X := R.Left + ws.MillimetersToPoints(CM, true);
           if X >= R.Right then
             Break;
           MoveTo(X, R.Top);
           LineTo(X, R.Top + 5);
           inc(Cm, 10);
      until False;
  end;
begin
   if ws.Mode = moNoObjects then
     Exit;
   ScrBM := TBitmap.Create;
   ScrBM.Width := PB.ClientRect.Right;
   ScrBM.Height := PB.ClientRect.Bottom;
   ScrBM.Canvas.Brush.Color := pb.Color;
   ScrBM.Canvas.FillRect(pb.ClientRect);
   try
     with ScrBM.Canvas do
     begin
          T := pb.ClientRect.Top;
          B := pb.ClientRect.Bottom;
          R := ws.PageRect;
          R.Top := T;
          R.Bottom := B;
          Brush.Color := clInfoBK;
          Font.Color := clBlack;
          FillRect(R);
          Pen.Color := clGray;

          DrawMetrics;

          MoveTo(ws.LeftMargin, T);
          LineTo(ws.Pagerect.Right, T);

          MoveTo(ws.LeftMargin, T);
          LineTo(ws.LeftMargin, B);
          MoveTo(ws.Pagerect.Right, T);
          LineTo(ws.Pagerect.Right, B);

          {Draw tab markers}
          TabWdth := ws.DefTabWidth;
          X := ws.LeftMargin;
          Para := ws.ParaAttributes[ws.CurrentParaNumber];
          with Para do
          begin
              Canvas.Pen.Width := 2;
              Canvas.Pen.Color := clBlack;
              for i := 0 to TabCount - 1 do
              begin
                  X := Tabs[i] + ws.LeftMargin;
                  MoveTo(X, B - 6);
                  LineTo(X, B - 1);
                  LineTo(X + 5, B - 1);
              end;
          end;
          LastParaTab := X;
          X := ws.LeftMargin;
          Pen.Width := 1;
          Pen.Color := clGray;
          while X < ws.Pagerect.Right do
          begin
            inc(X, TabWdth);
            if X > LastParaTab then
            begin
              MoveTo(X, B - 4);
              LineTo(X, B - 1);
            end;
          end;

          DiffX := FRulerX - FRulerStartX;
          BM := TBitmap.Create;
          {Draw indentation sliders}
          with Para do
          begin
             //First
             ImageList2.GetBitmap(0, BM);
             X := ws.LeftMargin + FirstIndent + LeftIndent + 1;
             if (FRulerMode = rmFirstIndent) or (FRulerMode = rmLeftIndent) then Inc(X, DiffX);
             BM.Transparent := True;
             ScrBM.Canvas.Draw(X, T+1, BM);

             //Hang
             BM.Free;
             BM := TBitmap.Create;
             ImageList2.GetBitmap(1, BM);
             X := para.LeftIndent + ws.LeftMargin + 1;
             if (FRulerMode = rmHangIndent) or (FRulerMode = rmLeftIndent) then Inc(X, DiffX);
             BM.Transparent := True;
             ScrBM.Canvas.Draw(X, T+1 + 10, BM);

             //Left
             BM.Free;
             BM := TBitmap.Create;
             ImageList2.GetBitmap(2, BM);
             X := para.LeftIndent + ws.LeftMargin + 1;
             if (FRulerMode = rmLeftIndent) or (FRulerMode = rmHangIndent) then Inc(X, DiffX);
             BM.Transparent := True;
             ScrBM.Canvas.Draw(X, T+1 + 20, BM);

             //Right
             BM.Free;
             BM := TBitmap.Create;
             ImageList2.GetBitmap(2, BM);
             X := ws.PageRect.Right - Para.RightIndent-10;
             if FRulerMode = rmRightIndent then Inc(X, DiffX);
             BM.Transparent := True;
             ScrBM.Canvas.Draw(X, T+1 + 20, BM);
             BM.Free;
          end;
     end;
     BitBlt(PB.Canvas.Handle, 0, 0, PB.ClientRect.Right, PB.ClientRect.Bottom,
       ScrBM.Canvas.Handle, 0, 0, SRCCOPY);
   finally
      ScrBM.Free;
   end;
end;

procedure TfrmHoved.pbMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{Initiate indentation slider dragging, when mouse is clicked on the ruler}
var
   R : TRect;
   P : TPoint;
begin
   if ws.Mode = moNoObjects then
     exit;
   P.X := X;
   P.Y := Y;
   R := FiRect;
   if PtInRect(R, P) then
   begin
         FRulerMode := rmFirstIndent;
         FRulerStartX := R.Left;
         FIndentRectDiff := X - R.Left;
         Exit;
   end;
   R := LiRect;
   if PtInRect(R, P) then
   begin
         FRulerMode := rmLeftIndent;
         FRulerStartX := R.Left;
         FIndentRectDiff := X - R.Left;
         Exit;
   end;
   R := HangRect;
   if PtInRect(R, P) then
   begin
         FRulerMode := rmHangIndent;
         FRulerStartX := R.Left;
         FIndentRectDiff := X - R.Left;
         Exit;
   end;
   R := RiRect;
   if PtInRect(R, P) then
   begin
         FRulerMode := rmRightIndent;
         FRulerStartX := R.Left;
         FIndentRectDiff := X - R.Left;
         Exit;
   end;
   FRulerX := FRulerStartX;
end;

procedure TfrmHoved.pbMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{Update para indentation values when a ruler dragging operation is finished}
var
  Para : TWSParagraph;
  Dist : integer;
begin
    if ws.Mode = moNoObjects then
      Exit;
    if FRulerMode = rmNoIndent then
      Exit;
    {One of the identation buttons on the ruler is released. Edit the
    indent properties}

    Para := ws.EditParagraph(ws.CurrentParaNumber);
    {Obtain the paraobject to be edited}
    Para.BeginChange;
    {Start a change transaction, as we might change more than one property.
    Doing this we ensure that undo recordings will be 'all in one' and not
    one by one}
    with Para do
    case FRulerMode of
       rmLeftIndent : LeftIndent := FRulerX - ws.LeftMargin;
       rmFirstIndent : FirstIndent := FRulerX - ws.LeftMargin - LeftIndent;
       rmHangIndent :
         begin
             Dist := LeftIndent;
             LeftIndent := FRulerX - ws.LeftMargin;
             Dist := Dist - LeftIndent;
             FirstIndent := FirstIndent + Dist;
         end;
       rmRightIndent : RightIndent := ws.PageRect.Right - FRulerX;
    end;
    Para.EndChange;
    {End transaction. This writes data to the undo buffer, sets the
    modify flag and ensures that the screen gets correctly updated}

    FRulerMode := rmNoIndent;
    FRulerStartX := 0;
    FRulerX := 0;
    InvalidatePB;
end;

procedure TfrmHoved.pbMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
{Moves the slider when a slider dragging operation is active}
var
   R : Trect;
begin
    if ws.Mode = moNoObjects then
      Exit;
      if FRulerMode = rmNoIndent then
        Exit;
      FRulerX := X - FIndentRectDiff;
      InvalidatePB;
      R := ws.ClientRect;
      InvalidateRect(Ws.Handle, @R, False);
end;

procedure TfrmHoved.wsDrawObject(Sender: TObject; Source: TWSObject;
  Canvas: TCanvas; X, Y: Integer; var DefaultDraw: Boolean);
{Draws the circle object in th TWSObjec demo screen}
var
  Rect : TRect;
  Clr : TColor;
begin
    if Source.Name <> 'MyCircle' then
      Exit;
    with Source as TWSGraphic do
    begin
        if (Width < 10) or (Height < 10) then
          Exit;
        Clr := Canvas.Brush.Color;
        Canvas.Brush.Color := clRed;
        with Rect do
        begin
          Left := X + 10;
          Top := Y + 10;
          Right := X + Width -10;
          Bottom := Y + Height -10;
        end;
        Canvas.Ellipse(Rect);
        Canvas.Brush.Color := Clr;
    end;
end;

procedure TfrmHoved.ac_InsertFileExecute(Sender: TObject);
begin
   if OpenDialog1.Execute then
     ws.InsertFile(OpenDialog1.FileName);
end;

procedure TfrmHoved.ToolButton11Click(Sender: TObject);
var
  Pt : TPoint;
  A : TAttributes;
begin
    A := ws.DefAttributes;
    A.FontName := 'Arial';
    A.FontSize := 10;
    ws.SetSelAttributes(A);
end;

procedure TfrmHoved.ac_ParaFormatExecute(Sender: TObject);
{Displays the para attributes dialog}
begin
   if dlgParaProps.ShowModal = mrOk then
     InvalidatePB;
end;

procedure TfrmHoved.ac_ParaFormatUpdate(Sender: TObject);
begin
  ac_ParaFormat.Enabled := (ws.Mode = moObjects);
end;

procedure TfrmHoved.ac_InsertObjectExecute(Sender: TObject);
{Inserts the circle object in the TWSObjects demo screen}
var
  Obj : TWSGraphic;
begin
    if ws.Mode = moNoObjects then
    begin
         ShowMessage('Please run WordSource in object mode (Mode = moObjects) to make this demo work.');
         Exit;
    end;
    Obj := TWSGraphic.Create(ws);
    Obj.Name := 'MyCircle';
    Obj.PictureType := pt_OwnerDraw;
    Obj.Width := 150;
    Obj.Height := 150;
    ws.AddTWSObject(Obj, ws.Selstart, -1);
end;

procedure TfrmHoved.ac_InsertObjectUpdate(Sender: TObject);
begin
  ac_InsertObject.Visible := (FCurScreen=3)
end;

procedure TfrmHoved.UsingTWSObject1Click(Sender: TObject);
begin
  FCurScreen := 3;
  SetScreen(3);
end;

procedure TfrmHoved.CreatinWinHelpfiles1Click(Sender: TObject);
begin
  FCurScreen := 4;
  SetScreen(4);
end;

procedure TfrmHoved.ac_NewTopicUpdate(Sender: TObject);
begin
     ac_NewTopic.Visible := (FCurScreen = 4);
end;

procedure TfrmHoved.ac_TopicLinkerUpdate(Sender: TObject);
begin
    ac_TopicLinker.Visible := (FCurScreen = 4);
end;

procedure TfrmHoved.ac_PasteExecute(Sender: TObject);
begin
     ws.PasteFromClipBoard;
end;

procedure TfrmHoved.ac_PasteUpdate(Sender: TObject);
begin
    ac_Paste.Enabled := ws.CanPaste;
end;

procedure TfrmHoved.ac_CopyExecute(Sender: TObject);
begin
    ws.CopyToClipBoard;
end;

procedure TfrmHoved.ac_CopyUpdate(Sender: TObject);
begin
   ac_Copy.Enabled := (ws.SelLength > 0);
end;

procedure TfrmHoved.ac_UndoExecute(Sender: TObject);
begin
   ws.Undo;
end;

procedure TfrmHoved.ac_UndoUpdate(Sender: TObject);
begin
  ac_Undo.Enabled := ws.CanUndo;
end;

procedure TfrmHoved.ac_NewTopicExecute(Sender: TObject);
var
  Attr : TAttributes;
  HasSub : Boolean;
  First : Boolean;
  Par : TWSParagraph;
  P : integer;

  procedure SetSub(Title : string);
  begin
       with dlgWinHelp, ws do
       begin
           if not First then
            TypeText('     ');
           Attr.DblUnderline := True;
           SetSelAttributes(Attr);
           TypeText(Title);
           Attr.DblUnderline := False;
           Attr.Hidden := True;
           SetSelAttributes(Attr);
           TypeText('IDH_');
           Attr.Hidden := False;
           SetSelAttributes(Attr);
           First := False;
       end;
  end;

begin
       if dlgWinhelp.ShowModal = mrOk then
       with WS, dlgWinHelp do
       begin
           AddFootnote(Selstart, '#', e_TopicID.Text);
           if Trim(e_TopicTitle.Text) <> '' then
             AddFootnote(Selstart, '$', e_TopicTitle.Text);
           if cbx_KeyNote.Checked then
           begin
               AddFootnote(Selstart, 'K', e_KeyWords.Text);
           end;
           if cbx_ANote.Checked then
           begin
               AddFootnote(Selstart, 'A', e_AWords.Text);
           end;

           Attr := FontToAttributes(TitleFont);
           SetSelAttributes(Attr);
           if cb_TopicType.ItemIndex = 0 then
             TypeText(e_CompName.Text)
           else if cb_TopicType.ItemIndex in [1..3] then
           begin
                TypeText(cb_TopicType.Text + ' ' + e_TopicTitle.Text + ' ' +
                '(' + e_CompName.Text + ')');
           end
           else if cb_TopicType.ItemIndex = 4 then
           begin
                TypeText('property' + ' ' + e_TopicTitle.Text + ' ' +
                '(' + e_CompName.Text + ')');
           end
           else
             TypeText(e_TopicTitle.Text);

           if e_TopicTitle.Text <> '' then
           begin
             Par := EditParagraph(CurrentParaNumber);
             Par.BeginChange;
             Par.KeepWithNext := True;
             Par.SpaceAfter := 4;
             Par.EndChange;
           end;

           HasSub := cbx_Methods.Checked or cbx_Properties.Checked
           or cbx_Events.Checked or cbx_Component.Checked
           or (cb_TopicType.ItemIndex = 0);

           if HasSub then
           begin
                 First := True;
                 Attr := FontToAttributes(SubTitleFont);
                 SetSelAttributes(Attr);
                 TypeText(LB);

                 if cb_TopicType.ItemIndex = 0 then
                 begin
                   Attr.FontStyle := [fsUnderline];
                   SetSelAttributes(Attr);
                   TypeText('Hierarchy');
                   Attr.FontStyle := [];
                   Attr.Hidden := True;
                   SetSelAttributes(Attr);
                   TypeText('IDH_');
                   Attr.Hidden := False;
                   SetSelAttributes(Attr);
                   First := False;
                 end;
                 if cbx_Component.Checked then
                 begin
                   SetSub(e_CompName.Text);
                 end;
                 if cbx_Properties.Checked then
                 begin
                   SetSub('Properties');
                 end;
                 if cbx_Methods.Checked then
                 begin
                   SetSub('Methods');
                 end;
                 if cbx_Events.Checked then
                 begin
                   SetSub('Events');
                 end;
           end;

           if e_TopicTitle.Text <> '' then
           begin
             TypeText(LB);
             Par := EditParagraph(CurrentParaNumber);
             Par.BeginChange;
             Par.KeepWithNext := False;
             Par.SpaceAfter := 0;
             Par.EndChange;
             Attr := ws.DefAttributes;
             SetSelAttributes(Attr);
             P := ws.SelStart;
             TypeText('Text');
             ws.SelStart := P;
             ws.SelLength := Length('Text');
           end;
       end;
end;

procedure TfrmHoved.ac_TopicLinkerExecute(Sender: TObject);
begin
    frmJumper.Show;
end;

procedure TfrmHoved.ac_BulletListExecute(Sender: TObject);
var
 Obj : TWSParagraph;
begin
     Obj := ws.EditParagraph(ws.CurrentParanumber);
     Obj.BeginChange;
     Obj.Numbering := pnBullet;
     Obj.LeftIndent := 48;
     Obj.FirstIndent := -24;
     Obj.EndChange;
     ws.InvalidatePage;
end;

procedure TfrmHoved.ac_BulletListUpdate(Sender: TObject);
begin
    with Sender as TAction do
    begin
      if ws.Mode = moNoObjects then Enabled := False
      else
        Enabled := (ws.ParaAttributes[ws.CurrentParaNumber].Numbering = pnNone);
    end;
end;

procedure TfrmHoved.ac_numberlistExecute(Sender: TObject);
var
 Obj : TWSParagraph;
begin
     Obj := ws.EditParagraph(ws.CurrentParanumber);
     Obj.BeginChange;
     Obj.Numbering := pnNumber;
     Obj.LeftIndent := 48;
     Obj.FirstIndent := -24;
     Obj.EndChange;
     ws.InvalidatePage;
end;

procedure TfrmHoved.wsObject(Sender: TObject; Source: TWSObject);
begin
      if Source is TWSFootnote then
      begin
         e_Footnote.Text := Source.Text;
         FCurrentFootNote := Source as TWSFootnote;
      end
      else if Source is TWSHyperLink then
      with Source as TWSHyperlink do
      begin
          StatusBar1.SimpleText := 'Hyperlink target: ' + Target;
      end;
end;

procedure TfrmHoved.ac_SaveAsExecute(Sender: TObject);
begin
     if SaveDialog1.Execute then
     begin
         if SaveDialog1.FilterIndex = 1 then
          ws.SaveToFile(Savedialog1.FileName, ws.RTFSaver)
         else
          ws.SaveToFile(Savedialog1.FileName, ws.PlainSaver);
         Caption := Savedialog1.FileName;
     end;

end;

procedure TfrmHoved.ac_UpdateFootNoteExecute(Sender: TObject);
begin
     FCurrentFootnote.Text := e_FootNote.Text;
end;

procedure TfrmHoved.ac_UpdateFootNoteUpdate(Sender: TObject);
begin
    ac_UpdateFootnote.Enabled := (FCurrentFootnote <> nil);
end;

procedure TfrmHoved.sbNewFNClick(Sender: TObject);
begin
    ws.AddFootnote(ws.Selstart, cbNewFN.Text, e_Footnote.Text);
end;

procedure TfrmHoved.ToolButton12Click(Sender: TObject);
var
  S : string;
begin
      S := InputBox('Goto page', 'PageNumber', '');
      ws.GoToPage(StrToInt(S));
end;

procedure TfrmHoved.wsSaveObject(Sender: TObject; Source: TWSObject);
begin
     if Source is TWSGraphic then
     with Source as TWSGraphic do
       SaveFormat := pt_WMF;
     {Default is pt_EMF. WMF to create winhelp graphics}
end;

procedure TfrmHoved.wsLimitation(Sender: TObject; ErrorCode: Integer;
  ErrorMsg: String; var Cancel: Boolean);
begin
     ShowMessage(ErrorMsg);
end;

procedure TfrmHoved.ReplaceDialog1Replace(Sender: TObject);
var
  All, Whole, CaseSens : Boolean;
  Res : integer;
begin
     All := (frReplaceAll in ReplaceDialog1.Options);
     Whole := (frWholeWord in ReplaceDialog1.Options);
     CaseSens := (frMatchCase in ReplaceDialog1.Options);
     Res := ws.ReplaceText(ReplaceDialog1.FindText, ReplaceDialog1.ReplaceText,
      ws.Selstart, All, CaseSens, Whole);
     showmessage(IntToStr(Res) + ' occurences replaced.'); 
end;

procedure TfrmHoved.wsReplaceText(Sender: TObject; OldText,
  NewText: String; Index: Integer; var Allow, Cancel: Boolean);
begin
    Allow := True;
    Cancel := False;
end;

procedure TfrmHoved.ac_ReplaceExecute(Sender: TObject);
begin
     ReplaceDialog1.Execute;
end;

procedure TfrmHoved.FormResize(Sender: TObject);
var
  Rest : integer;
  ScrollBarW : integer;
begin
     Rest := Width - ws.PaperWidth;
     pan_Left.Width := Rest div 2;
     pan_Right.Width := pan_Left.Width;
     ScrollBarW := ws.Width - ws.ClientWidth;
     if ScrollBarW > ws.RightMargin then
     begin
        ScrollBarW := ScrollBarW - ws.RightMargin;
        pan_Left.Width := pan_Left.Width - ScrollbarW;
        pan_Right.Width := pan_Left.Width;
     end;
end;

procedure TfrmHoved.wsMarker(Sender: TObject; TheString: String;
  Action: TTextChangeKind; Range: TRange);
var
  Attr : TAttributes;
begin
exit;
     Attr := ws.DefAttributes;
     Attr.FontColor := clRed;
     ws.SetTextAttributes(Attr, Range);
end;

procedure TfrmHoved.wsKeyString(Sender: TObject; TheString: String;
  Action: TTextChangeKind; Range: TRange);
var
  Attr : TAttributes;
begin
     exit;
     Attr := ws.DefAttributes;
     Attr.FontColor := clBlue;
     Attr.FontStyle := [fsbold];
     ws.SetTextAttributes(Attr, Range);
end;

procedure TfrmHoved.ac_HyperlinkExecute(Sender: TObject);
var
  S : string;
  HL : TWSHyperlink;
begin
      S := InputBox('Hyperlink', 'Target', 'http://');
      if S <>  'http://' then
      begin
           HL := TWSHyperlink.Create(ws, ws.SelLength);
           HL.Target := S;
           ws.AddTWSObject(HL, ws.SelStart, 0);
      end
      else
         Showmessage('No target chosen.');
end;

procedure TfrmHoved.ac_HyperlinkUpdate(Sender: TObject);
begin
     ac_Hyperlink.Enabled := (ws.SelLength > 0) and
     (ws.Mode = moObjects);
end;

procedure TfrmHoved.wsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Obj : TWSObject;
  Ind : integer;
begin
      if (ws.Mode = moObjects) and (Key = vk_Control) then
      begin
           Ind := ws.PointToIndex(ws.ScreenToClient(Mouse.CursorPos), False);
           if Ind = -1 then
             Exit;
           Obj := ws.GetTWSObject(Ind);
           if Obj is TWSHyperLink then
           with Obj as TWSHyperlink do
             RefreshCursor;
      end;
end;

procedure TfrmHoved.wsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Obj : TWSObject;
  Ind : integer;
begin
      if (ws.Mode = moObjects) and (Key = vk_Control) then
      begin
           Ind := ws.PointToIndex(ws.ScreenToClient(Mouse.CursorPos), False);
           if Ind = -1 then
             Exit;
           Obj := ws.GetTWSObject(Ind);
           if Obj is TWSHyperLink then
           with Obj as TWSHyperlink do
             RefreshCursor;
      end;
end;

end.
